#include "stdio.h"
#include "malloc.h"
#include "stdlib.h"

#define TRUE  1
#define FALSE 0
#define OK 1
#define ERROR 0
#define INFEASIBLE -1
#define OVERFLOW  -2
typedef int  Status;

#define MAXSIZE 100

// ˳̬洢ṹĶ
typedef struct {
    int *elem;
    int length;
    int size;
} SqList;

// ˳ĳʼ
Status InitList_Sq(SqList *L)
{
    L->elem = (int *)malloc(MAXSIZE * sizeof(int));
    if (!L->elem) {
        exit(OVERFLOW);
    }
    L->length = 0;
    L->size = MAXSIZE;
    return OK;
}

// λòҲ
Status GetElem_Sq(SqList L, int i, int *e)
{
    if (i < 1 || i > L.length) {
        return ERROR;
    }
    *e = L.elem[i - 1];
    return OK;
}

// ݲҲ
int LocateElem_Sq(SqList L, int e)
{
    for (int i = 0; i < L.length; i++) {
        if (L.elem[i] == e) {
            return i + 1;
        }
    }
    return 0;
}

// 
Status ListInsert_Sq(SqList *L, int i, int e)
{
    if (i < 1 || i > L->length + 1) {
        return ERROR;
    }
    if (L->length >= L->size) {
        return ERROR;
    }
    for (int j = L->length - 1; j >= i - 1; j--) {
        L->elem[j + 1] = L->elem[j];
    }
    L->elem[i - 1] = e;
    L->length++;
    return OK;
}

// ɾ
Status ListDelete_Sq(SqList *L, int i, int *e)
{
    if (i < 1 || i > L->length) {
        return ERROR;
    }
    *e = L->elem[i - 1];
    for (int j = i; j < L->length; j++) {
        L->elem[j - 1] = L->elem[j];
    }
    L->length--;
    return OK;
}

int main()
{
    SqList SL;
    InitList_Sq(&SL);

    for (int i = 1; i <= 5; i++) {
        ListInsert_Sq(&SL, i, i + 10);
    }

    int pos = LocateElem_Sq(SL, 15);
    if (pos != 0) {
        printf("Ԫ15λǣ%d\n", pos);
    } else {
        printf("˳ԱSLвԪ15\n");
    }

    int deletedElem;
    ListDelete_Sq(&SL, 2, &deletedElem);
    printf("ɾԪصֵǣ%d\n", deletedElem);

    int e;
    GetElem_Sq(SL, 2, &e);
    printf("λΪ2Ԫֵǣ%d\n", e);

    return 0;
}
